WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Attributes | List of all members
winstd::event_fn_auto_ret< T > Class Template Reference
Event Tracing for Windows API

Helper template to write an event on entry/exit of scope with one parameter (typically result). More...

`#include <ETW.h>`

## Public Member Functions
| event_fn_auto_ret (_In_ event_provider &ep, _In_ const EVENT_DESCRIPTOR *event_cons, _In_ const EVENT_DESCRIPTOR *event_dest, _In_z_ LPCSTR pszFnName, T &result)
| Writes the `event_cons` event.
| event_fn_auto_ret (_In_ const event_fn_auto_ret< T > &other)
| Copies the object.
| event_fn_auto_ret (_Inout_ event_fn_auto_ret< T > &&other)
| Moves the object.
| ~event_fn_auto_ret ()
| Writes the `event_dest` event.
event_fn_auto_ret & | operator= (_In_ const event_fn_auto_ret< T > &other)
| Copies the object.
event_fn_auto_ret & | operator= (_Inout_ event_fn_auto_ret< T > &&other)
| Moves the object.

## Protected Attributes
event_provider & | m_ep
| Reference to event provider in use.
const EVENT_DESCRIPTOR * | m_event_dest
| Event descriptor at destruction.
EVENT_DATA_DESCRIPTOR | m_desc [2]
| Function name and return value.
T & | m_result
| Function result.

## Detailed Description

template<class T>
class winstd::event_fn_auto_ret< T >

Helper template to write an event on entry/exit of scope with one parameter (typically result).

It writes one string event at creation and another at destruction, with allowing one sprintf type parameter for string event at destruction.

The documentation for this class was generated from the following file:

- include/WinStd/ETW.h